// SPDX-License-Identifier: GPL-3.0-or-later
// Auto-generated by generate_dab_cost.py
#include "dab_cost.h"
#include <dpcommon/common.h>
#include <dpmsg/blend_mode.h>

double DP_dab_cost_pixel(bool indirect, int blend_mode)
{
    if (indirect) {
        return 1.55709107208252;
    }
    else {
        switch (blend_mode) {
        case DP_BLEND_MODE_ERASE:
            return 2.46303490447998;
        case DP_BLEND_MODE_NORMAL:
            return 2.19817162322998;
        case DP_BLEND_MODE_MULTIPLY:
            return 5.54034115600586;
        case DP_BLEND_MODE_DIVIDE:
            return 29.7991072845459;
        case DP_BLEND_MODE_BURN:
            return 34.1730014038086;
        case DP_BLEND_MODE_DODGE:
            return 29.6883366088867;
        case DP_BLEND_MODE_DARKEN:
            return 6.11413378143311;
        case DP_BLEND_MODE_LIGHTEN:
            return 7.9408984375;
        case DP_BLEND_MODE_SUBTRACT:
            return 5.77422576141357;
        case DP_BLEND_MODE_ADD:
            return 8.88630948638916;
        case DP_BLEND_MODE_RECOLOR:
            return 2.30240348815918;
        case DP_BLEND_MODE_BEHIND:
            return 3.25817826080322;
        case DP_BLEND_MODE_COLOR_ERASE:
            return 20.5168133163452;
        case DP_BLEND_MODE_SCREEN:
            return 8.89554167938232;
        case DP_BLEND_MODE_NORMAL_AND_ERASER:
            return 2.24933799743652;
        case DP_BLEND_MODE_LUMINOSITY_SHINE_SAI:
            return 5.85153810119629;
        case DP_BLEND_MODE_OVERLAY:
            return 7.30985338592529;
        case DP_BLEND_MODE_HARD_LIGHT:
            return 6.88252424621582;
        case DP_BLEND_MODE_SOFT_LIGHT:
            return 10.6358661651611;
        case DP_BLEND_MODE_LINEAR_BURN:
            return 8.88370718383789;
        case DP_BLEND_MODE_LINEAR_LIGHT:
            return 7.04107376098633;
        case DP_BLEND_MODE_HUE:
            return 37.5599224700928;
        case DP_BLEND_MODE_SATURATION:
            return 25.3241357803345;
        case DP_BLEND_MODE_LUMINOSITY:
            return 14.8069245376587;
        case DP_BLEND_MODE_COLOR:
            return 40.9922177734375;
        case DP_BLEND_MODE_REPLACE:
            return 2.06645264434814;
        default:
            DP_debug("Unhandled blend mode %d", blend_mode);
            return 40.9922177734375;
        }
    }
}

double DP_dab_cost_pixel_square(bool indirect, int blend_mode)
{
    if (indirect) {
        return 1.02200807189941;
    }
    else {
        switch (blend_mode) {
        case DP_BLEND_MODE_ERASE:
            return 1.93756687927246;
        case DP_BLEND_MODE_NORMAL:
            return 1.67833213806152;
        case DP_BLEND_MODE_MULTIPLY:
            return 5.01599115753174;
        case DP_BLEND_MODE_DIVIDE:
            return 28.9503596572876;
        case DP_BLEND_MODE_BURN:
            return 33.3352295837402;
        case DP_BLEND_MODE_DODGE:
            return 28.843717956543;
        case DP_BLEND_MODE_DARKEN:
            return 5.59360440826416;
        case DP_BLEND_MODE_LIGHTEN:
            return 7.41837959289551;
        case DP_BLEND_MODE_SUBTRACT:
            return 4.40368714904785;
        case DP_BLEND_MODE_ADD:
            return 8.36066690826416;
        case DP_BLEND_MODE_RECOLOR:
            return 1.79620372009277;
        case DP_BLEND_MODE_BEHIND:
            return 2.75833290100098;
        case DP_BLEND_MODE_COLOR_ERASE:
            return 24.7095423355103;
        case DP_BLEND_MODE_SCREEN:
            return 8.37714343261719;
        case DP_BLEND_MODE_NORMAL_AND_ERASER:
            return 1.74597648620605;
        case DP_BLEND_MODE_LUMINOSITY_SHINE_SAI:
            return 5.33151686859131;
        case DP_BLEND_MODE_OVERLAY:
            return 6.7819123840332;
        case DP_BLEND_MODE_HARD_LIGHT:
            return 6.35907444000244;
        case DP_BLEND_MODE_SOFT_LIGHT:
            return 10.1076310882568;
        case DP_BLEND_MODE_LINEAR_BURN:
            return 8.36023349761963;
        case DP_BLEND_MODE_LINEAR_LIGHT:
            return 6.31751801300049;
        case DP_BLEND_MODE_HUE:
            return 36.7253607177734;
        case DP_BLEND_MODE_SATURATION:
            return 24.4847429122925;
        case DP_BLEND_MODE_LUMINOSITY:
            return 14.2864263687134;
        case DP_BLEND_MODE_COLOR:
            return 40.0210949554443;
        case DP_BLEND_MODE_REPLACE:
            return 1.54989241027832;
        default:
            DP_debug("Unhandled blend mode %d", blend_mode);
            return 40.0210949554443;
        }
    }
}

double DP_dab_cost_classic(bool indirect, int blend_mode)
{
    if (indirect) {
        return 8.38251396885338e-05;
    }
    else {
        switch (blend_mode) {
        case DP_BLEND_MODE_ERASE:
            return 9.78951886576304e-05;
        case DP_BLEND_MODE_NORMAL:
            return 9.4517730533485e-05;
        case DP_BLEND_MODE_MULTIPLY:
            return 0.0001468778392126;
        case DP_BLEND_MODE_DIVIDE:
            return 0.000528540607273098;
        case DP_BLEND_MODE_BURN:
            return 0.000597449437551021;
        case DP_BLEND_MODE_DODGE:
            return 0.000526750612591752;
        case DP_BLEND_MODE_DARKEN:
            return 0.000155976260771154;
        case DP_BLEND_MODE_LIGHTEN:
            return 0.000184652577875656;
        case DP_BLEND_MODE_SUBTRACT:
            return 0.000152510721756334;
        case DP_BLEND_MODE_ADD:
            return 0.000199687510901536;
        case DP_BLEND_MODE_RECOLOR:
            return 9.62869943894077e-05;
        case DP_BLEND_MODE_BEHIND:
            return 0.000111289313598914;
        case DP_BLEND_MODE_COLOR_ERASE:
            return 0.000383015930718057;
        case DP_BLEND_MODE_SCREEN:
            return 0.000199778153938804;
        case DP_BLEND_MODE_NORMAL_AND_ERASER:
            return 9.55647826827203e-05;
        case DP_BLEND_MODE_LUMINOSITY_SHINE_SAI:
            return 0.00015198122426659;
        case DP_BLEND_MODE_OVERLAY:
            return 0.000174193221302635;
        case DP_BLEND_MODE_HARD_LIGHT:
            return 0.000167651058452176;
        case DP_BLEND_MODE_SOFT_LIGHT:
            return 0.000227121331267993;
        case DP_BLEND_MODE_LINEAR_BURN:
            return 0.000199680423786125;
        case DP_BLEND_MODE_LINEAR_LIGHT:
            return 0.00017127239188265;
        case DP_BLEND_MODE_HUE:
            return 0.000650450720038807;
        case DP_BLEND_MODE_SATURATION:
            return 0.000457902213488944;
        case DP_BLEND_MODE_LUMINOSITY:
            return 0.000297001701851856;
        case DP_BLEND_MODE_COLOR:
            return 0.00070735355828382;
        case DP_BLEND_MODE_REPLACE:
            return 9.22735921088586e-05;
        default:
            DP_debug("Unhandled blend mode %d", blend_mode);
            return 0.00070735355828382;
        }
    }
}

double DP_dab_cost_mypaint(bool indirect, uint8_t lock_alpha, uint8_t colorize,
                           uint8_t posterize)
{
    if (indirect) {
        return 2.50561563613523e-05;
    }
    else {
        double cost = 0.0;
        if (lock_alpha != 0) {
            cost += 3.68085780733117e-05;
        }
        if (colorize != 0) {
            cost += 0.000637902510357074;
        }
        if (posterize != 0) {
            cost += 0.000203180407420541;
        }
        if (lock_alpha != UINT8_MAX && colorize != UINT8_MAX
            && posterize != UINT8_MAX) {
            cost += 3.46537103402587e-05;
        }
        return cost;
    }
}
